#ifndef __CLF_EFFECTS__
#define __CLF_EFFECTS__

class clf_fog{
	GLfloat fogColor[4];
	GLfloat fogStart, fogEnd;
	GLfloat fogDensity;
public:
	clf_fog(){
		// set default parameters
		fogColor[0] = 0.55f;
		fogColor[1] = 0.55f;
		fogColor[2] = 0.55f;
		fogColor[3] = .9f;
		fogStart = 0.1f;    // fog starts right from viewer's eyes
		fogEnd = 1500.f;			// and the furthest you can see is 180 units
		fogDensity = .1f;	// default density
	}

	~clf_fog(){
	}

	void fog_apply(){
		glFogi(GL_FOG_MODE, GL_LINEAR);			// Fog Mode, almost natural, the further the object the deeper in the fog
		glFogfv(GL_FOG_COLOR, fogColor);		// Fog Color, here we can simulate artificial fog effect with color
		glFogf(GL_FOG_DENSITY, fogDensity);	// How Dense Will The Fog Be
		glFogf(GL_FOG_START, fogStart);			// Fog Start Depth
		glFogf(GL_FOG_END, fogEnd);					// Fog End Depth, nothing is visible beyond that limit
		glEnable(GL_FOG);										// Enable GL_FOG
	}

	void fog_terminate(){
		glDisable(GL_FOG);					// disable GL_FOG
	}

	GLfloat& start(){
		return fogStart;  // fog start distance
	}
	GLfloat& end(){
		return fogEnd;		// fog end distance
	}
	GLfloat& density(){
		return fogDensity;	// fog density
	}
	GLfloat& red(){
		return fogColor[0];		// red coordinate of fog color
	}
	GLfloat& green(){
		return fogColor[1];		// green coordinate of fog color
	}
	GLfloat& blue(){
		return fogColor[2];		// blue coordinate of fog color
	}
	GLfloat& alpha(){
		return fogColor[3];		// alpha coordinate of fog color
	}
};

#endif // __CLF_EFFECTS__
