#ifndef __CLF_LIGHT__
#define __CLF_LIGHT__

#include "clf_math.h"

class clf_light{
	clFloat light_ambient[4];       // the colour and intesity of the ambient light
	clFloat light_diffuse[4];       // the difuse property of the surface
	clFloat light_specular[4];			// the specular property
	clf_vector4 light_position;
	unsigned int light_id;
public:
	clf_light(unsigned int id=GL_LIGHT0);
	~clf_light();
	void set_ambient(clFloat a0, clFloat a1, clFloat a2, clFloat a3);
	void set_diffuse(clFloat a0, clFloat a1, clFloat a2, clFloat a3);
	void set_specular(clFloat a0, clFloat a1, clFloat a2, clFloat a3);
	void set_position(clFloat x, clFloat y, clFloat z, clFloat w);
	clf_vector4& position();
	void apply();
	void draw_source();
	/////////////////////////////////////////////////////////////
	static void enable(){
		glEnable (GL_LIGHTING);					 // enable lighting
	}
	static void disable(){
		glDisable (GL_LIGHTING);					 // enable lighting
	}
};

#endif // __CLF_LIGHT__
